/*
 * Hantro Decoder device driver (kernel module)
*
* Copyright (C) 2020  VeriSilicon Microelectronics Co., Ltd.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
------------------------------------------------------------------------------*/

#include <linux/version.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/debugfs.h>
#include <linux/types.h>
#include <linux/device.h>
#include <linux/pagemap.h>
#include <linux/sched.h>
#include <linux/platform_device.h>
#include <linux/dma-buf.h>

#include "hantroafbc.h"

#define HANTRO_AFBC_OFFSET 0x20

void AFBCBypass(volatile unsigned char *hwregs)
{
	if (!hwregs)
		return;

	//AFBC pass through
	iowrite32(0x2, (void *)(hwregs + HANTRO_AFBC_OFFSET));
	printk(KERN_INFO "AFBC Bypass: 0x20 = 0x%x\n",
	       ioread32((void *)(hwregs + HANTRO_AFBC_OFFSET)));
}
